package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.BasicUnitMaintainDao;
import com.glxp.api.admin.entity.basic.BasicUnitMaintainEntity;
import com.glxp.api.admin.req.basic.BasicUnitMaintainFilterRequest;
import com.glxp.api.admin.req.basic.BasicUnitMaintainSaveRequest;
import com.glxp.api.admin.service.basic.BasicUnitMaintainService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class BasicUnitMaintainServiceImpl implements BasicUnitMaintainService {

    @Resource
    BasicUnitMaintainDao basicUnitMaintainDao;

    @Override
    public List<BasicUnitMaintainEntity> filterList(BasicUnitMaintainFilterRequest basicUnitMaintainFilterRequest) {
        if (basicUnitMaintainFilterRequest == null) {
            return Collections.emptyList();
        }
        int offset = (basicUnitMaintainFilterRequest.getPage() - 1) * basicUnitMaintainFilterRequest.getLimit();
        PageHelper.offsetPage(offset, basicUnitMaintainFilterRequest.getLimit());
        List<BasicUnitMaintainEntity> data = basicUnitMaintainDao.filterList(basicUnitMaintainFilterRequest);
        return data;
    }

    @Override
    public boolean insertBasicUnitMaintain(BasicUnitMaintainEntity basicUnitMaintainEntity) {
        return basicUnitMaintainDao.insertBasicUnitMaintain(basicUnitMaintainEntity);
    }

    @Override
    public boolean insert(BasicUnitMaintainEntity basicUnitMaintainEntity) {
        return basicUnitMaintainDao.insert(basicUnitMaintainEntity);
    }

    @Override
    public boolean updateById(BasicUnitMaintainSaveRequest basicUnitMaintainSaveRequest) {

        return basicUnitMaintainDao.updateById(basicUnitMaintainSaveRequest);
    }

    @Override
    public boolean deleteById(String id) {
        return basicUnitMaintainDao.deleteById(id);
    }

    @Override
    public BasicUnitMaintainEntity selectById(String id) {
        return basicUnitMaintainDao.selectById(id);
    }
}
