package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.BussinessTypeDao;
import com.glxp.api.admin.entity.basic.BussinessTypeEntity;
import com.glxp.api.admin.req.receipt.BussinessTypeFilterRequest;
import com.glxp.api.admin.service.basic.BussinessTypeService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class BussinessTypeServiceImpl implements BussinessTypeService {

    @Resource
    BussinessTypeDao bussinessTypeDao;

    @Override
    public List<BussinessTypeEntity> filterList(BussinessTypeFilterRequest bussinessTypeFilterRequest) {
        if (bussinessTypeFilterRequest == null) {
            return Collections.emptyList();
        }
        if(bussinessTypeFilterRequest.getPage()!=null){
            int offset = (bussinessTypeFilterRequest.getPage() - 1) * bussinessTypeFilterRequest.getLimit();
            PageHelper.offsetPage(offset, bussinessTypeFilterRequest.getLimit());
        }
        List<BussinessTypeEntity> data = bussinessTypeDao.filterList(bussinessTypeFilterRequest);
        return data;
    }

    @Override
    public BussinessTypeEntity findBTByAction(String action) {
        BussinessTypeFilterRequest bussinessTypeFilterRequest = new BussinessTypeFilterRequest();
        bussinessTypeFilterRequest.setAction(action);
        List<BussinessTypeEntity> data = bussinessTypeDao.filterList(bussinessTypeFilterRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public BussinessTypeEntity findBTByName(String action) {
        BussinessTypeFilterRequest bussinessTypeFilterRequest = new BussinessTypeFilterRequest();
        bussinessTypeFilterRequest.setName(action);
        List<BussinessTypeEntity> data = bussinessTypeDao.filterList(bussinessTypeFilterRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public boolean insertBussinessType(BussinessTypeEntity bussinessTypeEntity) {
        return bussinessTypeDao.insertBussinessType(bussinessTypeEntity);
    }

    @Override
    public boolean updateBussinessType(BussinessTypeEntity bussinessTypeEntity) {
        return bussinessTypeDao.updateBussinessType(bussinessTypeEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return bussinessTypeDao.deleteById(id);
    }
}
