package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.UdiRelevanceDao;
import com.glxp.api.admin.entity.basic.UdiInfoEntity;
import com.glxp.api.admin.entity.basic.UdiRelevanceEntity;
import com.glxp.api.admin.req.basic.FilterUdiInfoRequest;
import com.glxp.api.admin.res.basic.UdiRelevanceResponse;
import com.glxp.api.admin.service.basic.UdiRelevanceService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UdiRelevanceServiceImpl implements UdiRelevanceService {
    @Resource
    UdiRelevanceDao udiRelevanceDao;

    @Override
    public List<UdiRelevanceResponse> filterUdiRelevance(FilterUdiInfoRequest filterUdiInfoRequest) {
        if (filterUdiInfoRequest == null) {
            return Collections.emptyList();
        }
        if(filterUdiInfoRequest.getPage()!=null){
            int offset = (filterUdiInfoRequest.getPage() - 1) * filterUdiInfoRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiInfoRequest.getLimit());
        }

        List<UdiRelevanceResponse> data = udiRelevanceDao.filterUdiRelevance(filterUdiInfoRequest);
        return data;
    }

    @Override
    public List<UdiRelevanceResponse> filterUdiGp(FilterUdiInfoRequest filterUdiInfoRequest) {
        if (filterUdiInfoRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiInfoRequest.getPage() != null) {
            int offset = (filterUdiInfoRequest.getPage() - 1) * filterUdiInfoRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiInfoRequest.getLimit());
        }

        List<UdiRelevanceResponse> data = udiRelevanceDao.filterUdiGp(filterUdiInfoRequest);
        return data;
    }

    @Override
    public List<UdiRelevanceEntity> selectByUuid(String uuid) {
        return udiRelevanceDao.selectByUuid(uuid);
    }

    @Override
    public UdiRelevanceEntity selectById(String id) {
        return udiRelevanceDao.selectById(id);
    }

    @Override
    public UdiRelevanceEntity selectByThirdId(String thirdId) {
        return udiRelevanceDao.selectByThirdId(thirdId);
    }

    @Override
    public boolean insertUdiRelevance(UdiRelevanceEntity udiRelevanceEntity) {
        return udiRelevanceDao.insertUdiRelevance(udiRelevanceEntity);
    }

    @Override
    public boolean updateUdiRelevance(UdiRelevanceEntity udiRelevanceEntity) {
        return udiRelevanceDao.updateUdiRelevance(udiRelevanceEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return udiRelevanceDao.deleteById(id);
    }

    @Override
    public boolean deleteByIds(List<String> ids) {
        return udiRelevanceDao.deleteByIds(ids);
    }

    @Override
    public boolean deleteByUuid(String uuid) {
        return udiRelevanceDao.deleteByUuid(uuid);
    }
}
