package com.glxp.api.admin.thread;

import com.glxp.api.admin.entity.basic.UdiInfoEntity;
import com.glxp.api.admin.entity.basic.UdiRelevanceEntity;
import com.glxp.api.admin.httpclient.ErpBasicClient;
import com.glxp.api.admin.httpclient.ErpInvClient;
import com.glxp.api.admin.req.basic.FilterErpGoodsRequest;
import com.glxp.api.admin.req.inventory.ErpOnhandRequest;
import com.glxp.api.admin.res.PageSimpleResponse;
import com.glxp.api.admin.res.basic.ErpProductsResponse;
import com.glxp.api.admin.res.inventory.ErpOnHandResponse;
import com.glxp.api.admin.service.basic.UdiInfoService;
import com.glxp.api.admin.service.basic.UdiRelevanceService;
import com.glxp.api.admin.util.CustomUtil;
import com.glxp.api.admin.util.DateUtil;
import com.glxp.api.common.res.BaseResponse;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class BasicUpdateproductService {
    @Resource
    UdiRelevanceService udiRelevanceService;
    @Resource
    UdiInfoService udiInfoService;


    @Async
    public void updateProduct(String productUrl, String onHandUrl) {
        int page = 1;
        int limit = 100;
        while (page != -1) {
            page = getInvmandoc(null, page, limit, productUrl, onHandUrl);
        }
    }

    public void addProduct(String code, String name, String url) {
        List<String> inventoryCodes = new ArrayList<>();
        inventoryCodes.add(code);
        if (inventoryCodes.size() > 0) {
            UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
            udiRelevanceEntity1.setThirdId(code);
            udiRelevanceEntity1.setThirdName(name);
            udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());

            FilterErpGoodsRequest filterErpGoodsRequest = new FilterErpGoodsRequest();
            filterErpGoodsRequest.setCode(code);
            filterErpGoodsRequest.setPage(1);
            filterErpGoodsRequest.setLimit(1);
            BaseResponse<PageSimpleResponse<ErpProductsResponse>> erpProducts = new ErpBasicClient().getErpProducts(filterErpGoodsRequest, url);
            List<ErpProductsResponse> erpProductsResponses = erpProducts.getData().getList();
            if (erpProductsResponses != null & erpProductsResponses.size() > 0) {
                ErpProductsResponse erpProductsResponse = erpProductsResponses.get(0);
                UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
                udiInfoEntity.setNameCode(erpProductsResponse.getCode());
                udiInfoEntity.setCpmctymc(erpProductsResponse.getName());
                udiInfoEntity.setGgxh(erpProductsResponse.getSpec());
                udiInfoEntity.setZczbhhzbapzbh(erpProductsResponse.getRegisterNo());
                udiInfoEntity.setYlqxzcrbarmc(erpProductsResponse.getManufactory());
                udiInfoEntity.setUuid(CustomUtil.getUUId());
                udiInfoService.insertUdiInfo(udiInfoEntity);
                udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());
                udiRelevanceEntity1.setThirdId(udiInfoEntity.getNameCode());
                udiRelevanceEntity1.setThirdName(udiInfoEntity.getCpmctymc());
                udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());

            }
            udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
        }


    }


    public int getInvmandoc(String invcode, int page, int limit, String productUrl, String onHandUrl) {

        FilterErpGoodsRequest filterErpGoodsRequest = new FilterErpGoodsRequest();

        filterErpGoodsRequest.setPage(page);
        filterErpGoodsRequest.setLimit(limit);
        if (invcode != null) {
            filterErpGoodsRequest.setCode(invcode);
        }
        BaseResponse<PageSimpleResponse<ErpProductsResponse>> erpProducts = new ErpBasicClient().getErpProducts(filterErpGoodsRequest, productUrl);
        List<ErpProductsResponse> invmandocResponses = erpProducts.getData().getList();
        if (invmandocResponses != null && invmandocResponses.size() > 0) {
            List<String> inventoryCodes = new ArrayList<>();
            if (invcode != null) {
                inventoryCodes.add(invcode);
            } else {
                for (ErpProductsResponse invmandocResponse : invmandocResponses) {
                    UdiRelevanceEntity udiRelevanceEntity = udiRelevanceService.selectByThirdId(invmandocResponse.getCode());
                    if (udiRelevanceEntity == null) {
                        inventoryCodes.add(invmandocResponse.getCode());
                    }
                }
            }

            if (inventoryCodes.size() > 0) {

                ErpOnhandRequest erpOnhandRequest = new ErpOnhandRequest();
                erpOnhandRequest.setInventoryCodes(inventoryCodes);
                List<ErpOnHandResponse> erpOnHandResponses = new ErpInvClient().getOnHand(erpOnhandRequest, onHandUrl);
                if (erpOnHandResponses != null) {
                    Map<String, List<ErpOnHandResponse>> map = erpOnHandResponses.stream().collect(Collectors.groupingBy(ErpOnHandResponse::getInventoryCode));
                    for (List<ErpOnHandResponse> onHandResponses : map.values()) {
                        if (onHandResponses != null && onHandResponses.size() > 0) {
                            ErpOnHandResponse onhandQueryResponse = onHandResponses.get(0);
                            if (onhandQueryResponse.getCount() > 0) {
                                UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
                                udiInfoEntity.setNameCode(onhandQueryResponse.getInventoryCode());
                                udiInfoEntity.setCpmctymc(onhandQueryResponse.getInventoryName());
                                udiInfoEntity.setGgxh(onhandQueryResponse.getSpec());
                                udiInfoEntity.setUuid(CustomUtil.getUUId());
                                udiInfoEntity.setYlqxzcrbarmc(invmandocResponses.get(0).getManufactory());
                                udiInfoEntity.setZczbhhzbapzbh(invmandocResponses.get(0).getRegisterNo());
                                udiInfoService.insertUdiInfo(udiInfoEntity);
                                UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
                                udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());
                                udiRelevanceEntity1.setThirdId(onhandQueryResponse.getInventoryCode());
                                udiRelevanceEntity1.setThirdName(onhandQueryResponse.getInventoryName());
                                udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
                                udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
                            }

//                                }

                        }
                    }
                } else {
                    UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
                    udiRelevanceEntity1.setThirdId(invcode);
                    udiRelevanceEntity1.setThirdName(invmandocResponses.get(0).getName());
                    udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
                    udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
                }
            }
            page++;
            if (page * limit < erpProducts.getData().getTotal()) {
                return page;
            }
        } else {
            return -1;
        }

        return -1;
    }
}
